5 ## This script is the front-end to the build system. It provides a similar
6 ## interface to standard configure scripts with some extra bits for dealing
7 ## with toolchains that differ from the standard POSIX interface and
8 ## for extracting subsets of the source tree. In theory, reusable parts
9 ## of this script were intended to live in build/make/configure.sh,
10 ## but in practice, the line is pretty blurry.
12 ## This build system is based in part on the FFmpeg configure script.
15 #source_path="`dirname \"$0\"`"
17 . "${source_path}/build/make/configure.sh"
23 ${toggle_libs} don't build libraries
24 ${toggle_examples} don't build examples
25 ${toggle_unit_tests} build unit tests
26 --libc=PATH path to alternate libc
27 --as={yasm|nasm|auto} use specified assembler [auto, yasm preferred]
28 ${toggle_fast_unaligned} don't use unaligned accesses, even when
29 supported by hardware [auto]
30 ${toggle_codec_srcs} in/exclude codec library source code
31 ${toggle_debug_libs} in/exclude debug version of libraries
32 ${toggle_md5} support for output of checksum data
33 ${toggle_static_msvcrt} use static MSVCRT (VS builds only)
34 ${toggle_vp8} VP8 codec support
35 ${toggle_internal_stats} output of encoder internal stats for debug, if supported (encoders)
36 ${toggle_mem_tracker} track memory usage
37 ${toggle_postproc} postprocessing
38 ${toggle_multithread} multithreaded encoding and decoding.
39 ${toggle_spatial_resampling} spatial sampling (scaling) support
40 ${toggle_realtime_only} enable this option while building for real-time encoding
41 ${toggle_error_concealment} enable this option to get a decoder which is able to conceal losses
42 ${toggle_runtime_cpu_detect} runtime cpu detection
43 ${toggle_shared} shared library support
44 ${toggle_static} static library support
45 ${toggle_small} favor smaller size over speed
46 ${toggle_postproc_visualizer} macro block / block level visualizers
49 Codecs can be selectively enabled or disabled individually, or by family:
52 --disable-<codec>-encoder
53 --disable-<codec>-decoder
55 Codecs available in this distribution:
57 #restore editor state '
63 for c in ${CODECS}; do
65 if [ "${family}" != "${last_family}" ]; then
66 [ -z "${str}" ] || echo "${str}"
67 str="$(printf ' %10s:' ${family})"
69 str="${str} $(printf '%10s' ${c#*_})"
77 ## BEGIN APPLICATION SPECIFIC CONFIGURATION
80 # all_platforms is a list of all supported target platforms. Maintain
81 # alphabetically by architecture, generic-gnu last.
82 all_platforms="${all_platforms} armv5te-linux-rvct"
83 all_platforms="${all_platforms} armv5te-linux-gcc"
84 all_platforms="${all_platforms} armv5te-none-rvct"
85 all_platforms="${all_platforms} armv5te-symbian-gcc"
86 all_platforms="${all_platforms} armv6-darwin-gcc"
87 all_platforms="${all_platforms} armv6-linux-rvct"
88 all_platforms="${all_platforms} armv6-linux-gcc"
89 all_platforms="${all_platforms} armv6-none-rvct"
90 all_platforms="${all_platforms} armv6-symbian-gcc"
91 all_platforms="${all_platforms} iwmmxt-linux-rvct"
92 all_platforms="${all_platforms} iwmmxt-linux-gcc"
93 all_platforms="${all_platforms} iwmmxt2-linux-rvct"
94 all_platforms="${all_platforms} iwmmxt2-linux-gcc"
95 all_platforms="${all_platforms} armv7-darwin-gcc" #neon Cortex-A8
96 all_platforms="${all_platforms} armv7-linux-rvct" #neon Cortex-A8
97 all_platforms="${all_platforms} armv7-linux-gcc" #neon Cortex-A8
98 all_platforms="${all_platforms} armv7-none-rvct" #neon Cortex-A8
99 all_platforms="${all_platforms} mips32-linux-gcc"
100 all_platforms="${all_platforms} ppc32-darwin8-gcc"
101 all_platforms="${all_platforms} ppc32-darwin9-gcc"
102 all_platforms="${all_platforms} ppc32-linux-gcc"
103 all_platforms="${all_platforms} ppc64-darwin8-gcc"
104 all_platforms="${all_platforms} ppc64-darwin9-gcc"
105 all_platforms="${all_platforms} ppc64-linux-gcc"
106 all_platforms="${all_platforms} sparc-solaris-gcc"
107 all_platforms="${all_platforms} x86-darwin8-gcc"
108 all_platforms="${all_platforms} x86-darwin8-icc"
109 all_platforms="${all_platforms} x86-darwin9-gcc"
110 all_platforms="${all_platforms} x86-darwin9-icc"
111 all_platforms="${all_platforms} x86-darwin10-gcc"
112 all_platforms="${all_platforms} x86-linux-gcc"
113 all_platforms="${all_platforms} x86-linux-icc"
114 all_platforms="${all_platforms} x86-solaris-gcc"
115 all_platforms="${all_platforms} x86-win32-gcc"
116 all_platforms="${all_platforms} x86-win32-vs7"
117 all_platforms="${all_platforms} x86-win32-vs8"
118 all_platforms="${all_platforms} x86-win32-vs9"
119 all_platforms="${all_platforms} x86_64-darwin9-gcc"
120 all_platforms="${all_platforms} x86_64-darwin10-gcc"
121 all_platforms="${all_platforms} x86_64-linux-gcc"
122 all_platforms="${all_platforms} x86_64-linux-icc"
123 all_platforms="${all_platforms} x86_64-solaris-gcc"
124 all_platforms="${all_platforms} x86_64-win64-vs8"
125 all_platforms="${all_platforms} x86_64-win64-vs9"
126 all_platforms="${all_platforms} universal-darwin8-gcc"
127 all_platforms="${all_platforms} universal-darwin9-gcc"
128 all_platforms="${all_platforms} generic-gnu"
130 # all_targets is a list of all targets that can be configured
131 # note that these should be in dependency order for now.
132 all_targets="libs examples docs"
134 # all targets available are enabled, by default.
135 for t in ${all_targets}; do
136 [ -f ${source_path}/${t}.mk ] && enable ${t}
139 # check installed doxygen version
140 doxy_version=$(doxygen --version 2>/dev/null)
141 doxy_major=${doxy_version%%.*}
142 if [ ${doxy_major:-0} -ge 1 ]; then
143 doxy_version=${doxy_version#*.}
144 doxy_minor=${doxy_version%%.*}
145 doxy_patch=${doxy_version##*.}
147 [ $doxy_major -gt 1 ] && enable doxygen
148 [ $doxy_minor -gt 5 ] && enable doxygen
149 [ $doxy_minor -eq 5 ] && [ $doxy_patch -ge 3 ] && enable doxygen
152 # install everything except the sources, by default. sources will have
153 # to be enabled when doing dist builds, since that's no longer a common
155 enabled doxygen && php -v >/dev/null 2>&1 && enable install_docs
161 enable fast_unaligned #allow unaligned accesses, if supported by hw
163 enable spatial_resampling
167 [ -d ${source_path}/../include ] && enable alt_tree_layout
169 [ -d ${source_path}/${d} ] && disable alt_tree_layout;
172 if ! enabled alt_tree_layout; then
173 # development environment
174 [ -d ${source_path}/vp8 ] && CODECS="${CODECS} vp8_encoder vp8_decoder"
176 # customer environment
177 [ -f ${source_path}/../include/vpx/vp8cx.h ] && CODECS="${CODECS} vp8_encoder"
178 [ -f ${source_path}/../include/vpx/vp8dx.h ] && CODECS="${CODECS} vp8_decoder"
180 [ -f ${source_path}/../lib/*/*mt.lib ] && soft_enable static_msvcrt
183 CODECS="$(echo ${CODECS} | tr ' ' '\n')"
184 CODEC_FAMILIES="$(for c in ${CODECS}; do echo ${c%_*}; done | sort | uniq)"
312 --disable-codecs) for c in ${CODECS}; do disable $c; done ;;
313 *) process_common_cmdline "$opt"
319 post_process_cmdline() {
322 # If the codec family is disabled, disable all components of that family.
323 # If the codec family is enabled, enable all components of that family.
324 log_echo "Configuring selected codecs"
325 for c in ${CODECS}; do
326 disabled ${c%%_*} && disable ${c}
327 enabled ${c%%_*} && enable ${c}
330 # Enable all detected codecs, if they haven't been disabled
331 for c in ${CODECS}; do soft_enable $c; done
333 # Enable the codec family if any component of that family is enabled
334 for c in ${CODECS}; do
335 enabled $c && enable ${c%_*}
338 # Set the {en,de}coders variable if any algorithm in that class is enabled
339 for c in ${CODECS}; do
340 enabled ${c} && enable ${c##*_}s
346 enabled child || write_common_config_banner
347 enabled universal || write_common_target_config_h ${BUILD_PFX}vpx_config.h
349 # TODO: add host tools target (obj_int_extract, etc)
351 # For fat binaries, call configure recursively to configure for each
352 # binary architecture to be included.
353 if enabled universal; then
354 # Call configure (ourselves) for each subarchitecture
355 for arch in $fat_bin_archs; do
356 BUILD_PFX=${arch}/ toolchain=${arch} $self --child $cmdline_args || exit $?
360 # The write_common_config (config.mk) logic is deferred until after the
361 # recursive calls to configure complete, becuase we want our universal
362 # targets to be executed last.
363 write_common_config_targets
364 enabled universal && echo "FAT_ARCHS=${fat_bin_archs}" >> config.mk
366 # Calculate the default distribution name, based on the enabled features
369 for cf in $CODEC_FAMILIES; do
370 if enabled ${cf}_encoder && enabled ${cf}_decoder; then
371 DIST_DIR="${DIST_DIR}-${cf}"
372 elif enabled ${cf}_encoder; then
373 DIST_DIR="${DIST_DIR}-${cf}cx"
374 elif enabled ${cf}_decoder; then
375 DIST_DIR="${DIST_DIR}-${cf}dx"
378 enabled debug_libs && DIST_DIR="${DIST_DIR}-debug"
379 enabled codec_srcs && DIST_DIR="${DIST_DIR}-src"
380 ! enabled postproc && DIST_DIR="${DIST_DIR}-nopost"
381 ! enabled multithread && DIST_DIR="${DIST_DIR}-nomt"
382 ! enabled install_docs && DIST_DIR="${DIST_DIR}-nodocs"
383 DIST_DIR="${DIST_DIR}-${tgt_isa}-${tgt_os}"
385 win*) enabled static_msvcrt && DIST_DIR="${DIST_DIR}mt" || DIST_DIR="${DIST_DIR}md"
386 DIST_DIR="${DIST_DIR}-${tgt_cc}"
389 if [ -f "${source_path}/build/make/version.sh" ]; then
390 local ver=`"$source_path/build/make/version.sh" --bare $source_path`
391 DIST_DIR="${DIST_DIR}-${ver}"
392 VERSION_STRING=${ver}
394 VERSION_PATCH=${ver##*.}
396 VERSION_MINOR=${ver##*.}
398 VERSION_MAJOR=${ver%.*}
400 enabled child || cat <<EOF >> config.mk
403 ifeq (\$(MAKECMDGOALS),dist)
404 DIST_DIR?=${DIST_DIR}
406 DIST_DIR?=\$(DESTDIR)${prefix}
408 LIBSUBDIR=${libdir##${prefix}/}
410 VERSION_STRING=${VERSION_STRING}
412 VERSION_MAJOR=${VERSION_MAJOR}
413 VERSION_MINOR=${VERSION_MINOR}
414 VERSION_PATCH=${VERSION_PATCH}
416 CONFIGURE_ARGS=${CONFIGURE_ARGS}
418 enabled child || echo "CONFIGURE_ARGS?=${CONFIGURE_ARGS}" >> config.mk
421 # Write makefiles for all enabled targets
423 for tgt in libs examples docs solution; do
424 local tgt_fn="$tgt-$toolchain.mk"
426 if enabled $tgt; then
427 echo "Creating makefiles for ${toolchain} ${tgt}"
428 write_common_target_config_mk $tgt_fn ${BUILD_PFX}vpx_config.h
436 if enabled shared; then
437 # Can only build shared libs on a subset of platforms. Doing this check
438 # here rather than at option parse time because the target auto-detect
439 # magic happens after the command line has been parsed.
440 enabled linux || die "--enable-shared only supported on ELF for now"
442 if [ -z "$CC" ]; then
443 echo "Bypassing toolchain for environment detection."
444 enable external_build
446 log fake_check_header "$@"
449 var=`echo $header | sed 's/[^A-Za-z0-9_]/_/g'`
458 [ -f "${d##-I}/$header" ] && result=true && break
467 check_header stdio.h || die "Unable to invoke compiler: ${CC} ${CFLAGS}"
468 check_ld <<EOF || die "Toolchain is unable to link executables"
469 int main(void) {return 0;}
471 # check system headers
472 check_header stdint.h
473 check_header pthread.h
474 check_header sys/mman.h
476 check_header vpx/vpx_integer.h -I${source_path} && enable vpx_ports
479 process_toolchain() {
480 process_common_toolchain
482 # Handle universal binaries for this architecture
485 local darwin_ver=${tgt_os##darwin}
486 fat_bin_archs="$fat_bin_archs ppc32-${tgt_os}-gcc"
489 fat_bin_archs="$fat_bin_archs x86-${tgt_os}-${tgt_cc}"
490 if [ $darwin_ver -gt 8 ]; then
491 fat_bin_archs="$fat_bin_archs x86_64-${tgt_os}-${tgt_cc}"
497 # Enable some useful compiler flags
499 enabled werror && check_add_cflags -Werror
500 check_add_cflags -Wall
501 check_add_cflags -Wdeclaration-after-statement
502 check_add_cflags -Wdisabled-optimization
503 check_add_cflags -Wpointer-arith
504 check_add_cflags -Wtype-limits
505 check_add_cflags -Wcast-qual
506 enabled extra_warnings || check_add_cflags -Wno-unused-function
510 enabled werror && check_add_cflags -Werror
511 check_add_cflags -Wall
512 check_add_cflags -Wpointer-arith
514 # ICC has a number of floating point optimizations that we disable
515 # in favor of deterministic output WRT to other compilers
516 add_cflags -fp-model precise
519 # Enable extra, harmless warnings. These might provide additional insight
520 # to what the compiler is doing and why, but in general, but they shouldn't
521 # be treated as fatal, even if we're treating warnings as errors.
523 -Wdisabled-optimization
526 enabled gcc && EXTRA_WARNINGS="${GCC_EXTRA_WARNINGS}"
527 RVCT_EXTRA_WARNINGS="
530 enabled rvct && EXTRA_WARNINGS="${RVCT_EXTRA_WARNINGS}"
531 if enabled extra_warnings; then
532 for w in ${EXTRA_WARNINGS}; do
533 check_add_cflags ${w}
534 enabled gcc && enabled werror && check_add_cflags -Wno-error=${w}
538 # ccache only really works on gcc toolchains
539 enabled gcc || soft_disable ccache
540 if enabled mips; then
541 enable dequant_tokens
545 # Enable the postbuild target if building for visual studio.
549 vs_version=${tgt_cc##vs}
550 all_targets="${all_targets} solution"
554 # Other toolchain specific defaults
555 case $toolchain in x86*|ppc*|universal*) soft_enable postproc;; esac
557 if enabled postproc_visualizer; then
558 enabled postproc || die "postproc_visualizer requires postproc to be enabled"
564 ## END APPLICATION SPECIFIC CONFIGURATION
568 print_webm_license ${BUILD_PFX}vpx_config.c "/*" " */"
569 cat <<EOF >> ${BUILD_PFX}vpx_config.c
570 static const char* const cfg = "$CONFIGURE_ARGS";
571 const char *vpx_codec_build_config(void) {return cfg;}